#include "atmaal.h"

ATMAal::ATMAal()
{
	flag_=0;		//0 ->Empty, 1->Full
	seq_no_=0;
	tcp_seq_=-1;
	tcp_port=-1;
	tcp_addr=-1;
}
ATMAal::~ATMAal()
{
}

/* 
 * Receives a cell and returns whether the packet is complete or not.
 */
int ATMAal::Receive_Cell(ATMCell* cell)	//returns 1 if packet complete
{
	int complete=0;

        //if it is sequence number 1 it means that it is the 
        //first cell of any particular packet.
        //so insert the cell into the buffer and mark it full
        if(cell->atmseq_no_ == 1 )
        {
		//If only cell of the packet then return full
		if (cell->atmseq_no_ == cell->total_cells_) {
			complete=1;
                	flag_=0;    
		}
		else {
			seq_no_=cell->atmseq_no_;
			tcp_seq_=cell->seqno_;
                	flag_=1;    
			tcp_port=cell->sport_;
			tcp_addr=cell->src_;
		}
        }
        else if(!flag_)	//If Empty and the cell is not sequence number 1
		//then discard, since you would not be able to recover packet
                ;

        //if the cell is next in sequence then insert.
        else if(seq_no_ + 1 == cell->atmseq_no_ && tcp_seq_ == cell->seqno_
		&& tcp_port==cell->sport_ && tcp_addr==cell->src_)
        {
		//If it was the last cell then return it complete
		if (cell->atmseq_no_ == cell->total_cells_) {
			complete=1;
                	flag_=0;    
		}
		else{
                	flag_=1;		//FULL
			seq_no_++;
		}
        }
        else
                flag_=0;
       
	if(complete)
		return 1;
	return 0;
}
