#include "atmcell.h"
#ifndef aal_h

/*
 * In real life the AAL layer needs to keep the record of all the cells in a 
 * particular packet from a connection. In our design we only need the last 
 * last cell received. This is valid since the aal layer is seperate for every
 * source. So from one source cells from two different packets will arrive in
 * the same sequence i.e. the cells from the two packets would not overlap.
 * Thus only looking at the next cell, if it is out of sequence we can empty
 * the aal buffer
 */

class ATMAal{
        private:
                int flag_;	//0 if buffer empty, 1 otherwise
		int seq_no_;	//Cell sequence number
		int tcp_seq_;	//TCP packet sequence number
	
		int tcp_port;	//These two combined identify that the cells
				//are indeed from the same packet, because
			//two cells from different agents can have the same
			//sequence numbers.
		int tcp_addr;
        public:
                ATMAal();	
                ~ATMAal();

                int Receive_Cell(ATMCell*);
};
#define aal_h
#endif
