#ifndef atm_agent_
#define atm_agent_

#include "scheduler.h"
#include "object.h"
#include "agent.h"
#include "atmtrace.h"

class ATMSource;

class QOS : public NsObject {
	public:
		QOS();
		int command(int argc, const char*const* argv);
	double PCR;	//Peak Cell Rate
	double SCR;	//Sustained (avg) Cell Rate
	double MCR;	//Minimium Cell Rate
	double CDVT;	//Cell Delay Variation
	double CLR;	//Cell Loss Ratio
	double CTD;	//Cell Transfer Delay
};

class ATMAgent : public Agent {
	public:
		int command(int argc, const char*const* argv);
		virtual void handle(Event*)=0;
		virtual void start()=0;
		virtual void stop()=0;
		ATMAgent();
	protected:
		ATMSource* atmnode_;	//The node to which I belong
		QOS * qos_;		//The QOS requirements
		ATMTrace* trace_;
		int status;		//On or off
};

#endif
