#ifndef ns_atm_cell
#define ns_atm_cell
#include "packet.h"
#include <fstream.h>

/*
 * The ATMCell is derived from the Packet so that conversion across them is
 * easy and also the cell can be placed in the Event list
 */

class ATMCell : public Packet {
 public:
        int source_;	//The ATM Source
        int dest_; 	//The ATM Destination
        int total_cells_; //The Total Number of cells if from a packet
        int atmseq_no_;	//The ATM sequence number.
	int priority_;	//0 means UBR. 1 means VBR or CBR
	int queued_;	//1 if in queue 0 otherwise
	friend ostream& operator<<(ostream & os,const ATMCell* cell)
	{
		if(cell->priority_)
			os<<"CBR  ";
		else
			os<<"UBR  ";
		os<<cell->seqno_<<" ("<<cell->atmseq_no_<<","
			<<cell->total_cells_<<")\t"
			<<cell->source_<<" -> "<<cell->dest_
			<<"\t("<<cell->src_<<" => "<<cell->dst_<<")";
		return os;
	};
};      
#endif
