#ifndef lint
static char rcsid[] =
    "@(#) $Header: misc.cc,v 1.5 96/01/26 14:33:40 mccanne Exp $ (LBL)";
#endif

#include <fstream.h>
#include <stdlib.h>
#include <math.h>
#include <sys/time.h>
#include "scheduler.h"
#include "Tcl.h"
#include "random.h"

#include "node.h"
#include "atmnetwork.h"

/*
 * User input command is translated into the command function by identifying
 * the keyword "connect"
 */
static class ATMCommand : public TclObject {
public:
	ATMCommand() : TclObject("connect") { }
        virtual int command(int argc, const char*const* argv);
} atm_cmd;

/*
 * This handles the command for connecting a tcpnode to an atmnode
 * ns connect $tcpnode $atmnetwork $atmnode
 */

int ATMCommand::command(int argc, const char*const* argv)
{

	Tcl & tcl=Tcl::instance();
	if(argc==4)
	{
		//Lookup for all three objects and then attach them

		ATMNetwork * net=(ATMNetwork*)lookup(argv[2]);
		Node * tcp_node=(Node*)lookup(argv[1]);
		ATMNode * node=(ATMNode*)lookup(argv[3]);
		if(!net)
		{
			tcl.result("connect: Unable to find network");
			return (TCL_ERROR);
		}
		if(!tcp_node)
		{
			tcl.result("connect: Unable to find TCP node");
			return (TCL_ERROR);
		}
		if(!node)
		{
			tcl.result("connect: Unable to find ATM node");
			return (TCL_ERROR);
		}
		net->attach(tcp_node, node);
		return (TCL_OK);
	}
	return (TclObject::command(argc,argv));
}
