#ifndef atm_discard_h
#define atm_discard_h

#include "atmswitch.h"

/*
 * These set of classes are for switches of various types and their discard
 * algorithms. Given the current buffer, the current cell and the port, they
 * return whether to discard the cell or not.
 */

class SimpleOutputBuffer : public DiscardAlgorithm {
	public:
		virtual int check_discard(const ATMSwitchBuffer* buffer, 
					const ATMCell* cell, int);
};

class SimpleSharedBuffer : public DiscardAlgorithm {
	public:
		virtual int check_discard(const ATMSwitchBuffer* buffer, 
					const ATMCell* cell, int);
};

class EarlyOutputBuffer : public DiscardAlgorithm {
		double weight_;		//weight gives the percentage of the
			//queue to be full before discarding the UBR cells
	public:
		EarlyOutputBuffer();
		virtual int check_discard(const ATMSwitchBuffer* buffer, 
					const ATMCell* cell, int);
};

class EarlySharedBuffer : public DiscardAlgorithm {
		double weight_;
        public:
		EarlySharedBuffer() ;
                virtual int check_discard(const ATMSwitchBuffer* buffer,
					const ATMCell* cell, int);
};

#endif
