#include "atmroute.h"


class q_entry {
public:
	int node;
	q_entry* next_;
};

class queue {
public:
        queue(): len_(0), head_(0), tail_(&head_){};
	
        inline int length() const { return (len_); };
	inline int empty() const { return (!len_); };
        inline void enque(q_entry* p) {
                *tail_ = p;
                tail_ = &p->next_;
                *tail_ = 0;
                ++len_;
        };
        q_entry* deque() {
                q_entry* p = head_;
                if (p != 0) {
                        --len_;
                        head_ = p->next_;
                        if (head_ == 0)
                                tail_ = &head_;
                }
                return (p);
        };
protected:
        q_entry* head_;
        q_entry** tail_;
        int len_;
};

/*
 * This class uses the minimum hop algorithm between all sources and all 
 * all destinations. At the very first try it establishes all the paths
 * If a node is added after computing the routes, simply reset done to 0
 */
class ATMMinHop : public ATMRouteLogic{
  private:
	int done;
  public:
	ATMMinHop():done(0){};
	double establish_route(int,int);
	//int command(int argc, const char*const* argv);
};

/*
 * Matcher class for this. The id is "min-hop"
 */
class ATMMinHopRouteLogicMatcher : public Matcher {
public:
        ATMMinHopRouteLogicMatcher() : Matcher("min-hop") {};
        TclObject* match(const char* id) {
                return (new ATMMinHop());
        };
} atm_minhop_matcher;

	/*
int ATMMinHop::command(int argc, const char*const* argv)
{
        if (argc == 2) {
                if (strcmp(argv[1], "compute-routes") == 0) {
                        compute_routes();
                        return (TCL_OK);
                }
        }
	else if (argc == 3) {
                if (strcmp(argv[1], "insert") == 0) {
                        Node* p = (Node*)TclObject::lookup(argv[2]);
                        p->next_ = nodes_;
                        nodes_ = p;
                        return (TCL_OK);
                }
        }
        return (TclObject::command(argc, argv));
}
	*/

/*
 * Creates an all to all shortest path and returns 0 as the delay for 
 * establishing the routing tables. 
 */
double ATMMinHop::establish_route(int src,int dst)
{
	if(done)
		return 0.0;
	
	queue Q;
	q_entry* u,*v;
	
	int* status=new int[curr_nodes_];
	int* d=new int[curr_nodes_];
	int* parent=new int[curr_nodes_];

	ofstream fout("outp");

	for(int i=0;i<curr_nodes_;i++)
	{
		for(int j=0;j<curr_nodes_;j++)
		{
			if(lnk_tbl_[i][j])
				fout<<1<<' ';
			else 
				fout<<0<<' ';
		}
		fout<<'\n';
	}
	
	//Breadth first search
	for(int i=0;i<curr_nodes_;i++)
	{
		for(int j=0;j<curr_nodes_;j++)
		{
			status[j]=0;
			d[j]=-1;	//infinity
			parent[i]=-1;	//None
		}
		status[i]=1;
		d[i]=0;
		u=new q_entry;
		u->node=i;
		u->next_=NULL;
		Q.enque(u);
		while(!Q.empty())
		{
			u=Q.deque();
			for(int k=0;k<curr_nodes_;k++)
			{
				if(lnk_tbl_[u->node][k])	//If there is a link
					if(status[k]==0)
					{
						status[k]=1;
						d[k]=d[u->node]+1;
						parent[k]=u->node;
						v=new q_entry;
						v->node=k;
						v->next_=NULL;
						Q.enque(v);
					}
			}
			status[u->node]=2;
			delete u;
		}
		for(int j=0;j<curr_nodes_;j++)
		{
			for(int h=j;parent[h]!=i && parent[h]!=-1;h=parent[h]);
			if(parent[h]!=-1)
			{
				nodes_[i]->add_route(j,lnk_tbl_[i][h]);
				fout<<i<<"->"<<j<<"="<<h<<'\n';
			}
		}
	}
	fout.close();
	done=1;
	delete status;
	delete d;
	delete parent;
	return 0.0;
}
